# coding: utf-8

"""
    Civitai Orchestration Consumer API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self


class CustomAttributeData(BaseModel):
    """
from civitai_py.models.constructor_info import ConstructorInfo
from civitai_py.models.type import Type
from civitai_py.models.custom_attribute_typed_argument import CustomAttributeTypedArgument
from civitai_py.models.custom_attribute_named_argument import CustomAttributeNamedArgument
    CustomAttributeData
    """  # noqa: E501
    attribute_type: Optional[Type] = Field(default=None, alias="attributeType")
    constructor: Optional[ConstructorInfo] = None
    constructor_arguments: Optional[List[CustomAttributeTypedArgument]] = Field(
        default=None, alias="constructorArguments")
    named_arguments: Optional[List[CustomAttributeNamedArgument]
                              ] = Field(default=None, alias="namedArguments")
    __properties: ClassVar[List[str]] = ["attributeType",
                                         "constructor", "constructorArguments", "namedArguments"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomAttributeData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "constructor_arguments",
            "named_arguments",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attribute_type
        if self.attribute_type:
            _dict['attributeType'] = self.attribute_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of constructor
        if self.constructor:
            _dict['constructor'] = self.constructor.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in constructor_arguments (list)
        _items = []
        if self.constructor_arguments:
            for _item in self.constructor_arguments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['constructorArguments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in named_arguments (list)
        _items = []
        if self.named_arguments:
            for _item in self.named_arguments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['namedArguments'] = _items
        # set to None if constructor_arguments (nullable) is None
        # and model_fields_set contains the field
        if self.constructor_arguments is None and "constructor_arguments" in self.model_fields_set:
            _dict['constructorArguments'] = None

        # set to None if named_arguments (nullable) is None
        # and model_fields_set contains the field
        if self.named_arguments is None and "named_arguments" in self.model_fields_set:
            _dict['namedArguments'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomAttributeData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attributeType": Type.from_dict(obj["attributeType"]) if obj.get("attributeType") is not None else None,
            "constructor": ConstructorInfo.from_dict(obj["constructor"]) if obj.get("constructor") is not None else None,
            "constructorArguments": [CustomAttributeTypedArgument.from_dict(_item) for _item in obj["constructorArguments"]] if obj.get("constructorArguments") is not None else None,
            "namedArguments": [CustomAttributeNamedArgument.from_dict(_item) for _item in obj["namedArguments"]] if obj.get("namedArguments") is not None else None
        })
        return _obj


# TODO: Rewrite to not use raise_errors
CustomAttributeData.model_rebuild(raise_errors=False)
