# coding: utf-8

"""
    Civitai Orchestration Consumer API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from civitai_py.models.scheduler import Scheduler
from typing import Optional, Set
from typing_extensions import Self


class ImageJobParams(BaseModel):
    """
    ImageJobParams
    """  # noqa: E501
    prompt: Optional[StrictStr] = None
    negative_prompt: Optional[StrictStr] = Field(default=None, alias="negativePrompt")
    scheduler: Optional[Scheduler] = None
    steps: Optional[Annotated[int, Field(le=150, strict=True, ge=1)]] = None
    cfg_scale: Optional[Union[Annotated[float, Field(le=30, strict=True, ge=1)], Annotated[int, Field(
        le=30, strict=True, ge=1)]]] = Field(default=None, alias="cfgScale")
    width: Annotated[int, Field(le=2048, strict=True, ge=64)]
    height: Annotated[int, Field(le=2048, strict=True, ge=64)]
    seed: Optional[Annotated[int, Field(le=4294967295, strict=True, ge=-1)]] = None
    clip_skip: Optional[StrictInt] = Field(default=None, alias="clipSkip")
    __properties: ClassVar[List[str]] = ["prompt", "negativePrompt",
                                         "scheduler", "steps", "cfgScale", "width", "height", "seed", "clipSkip"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImageJobParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if prompt (nullable) is None
        # and model_fields_set contains the field
        if self.prompt is None and "prompt" in self.model_fields_set:
            _dict['prompt'] = None

        # set to None if negative_prompt (nullable) is None
        # and model_fields_set contains the field
        if self.negative_prompt is None and "negative_prompt" in self.model_fields_set:
            _dict['negativePrompt'] = None

        # set to None if cfg_scale (nullable) is None
        # and model_fields_set contains the field
        if self.cfg_scale is None and "cfg_scale" in self.model_fields_set:
            _dict['cfgScale'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImageJobParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "prompt": obj.get("prompt"),
            "negativePrompt": obj.get("negativePrompt"),
            "scheduler": obj.get("scheduler"),
            "steps": obj.get("steps"),
            "cfgScale": obj.get("cfgScale"),
            "width": obj.get("width"),
            "height": obj.get("height"),
            "seed": obj.get("seed"),
            "clipSkip": obj.get("clipSkip")
        })
        return _obj
